## hhvm 3.2.0+dfsg1

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.7 FATAL_ERROR)
PROJECT(hphp C CXX ASM)

IF(NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
  message(FATAL_ERROR "HHVM requires a 64bit OS")
ENDIF()

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake" ${CMAKE_MODULE_PATH})

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third-party/CMakeLists.txt")
  message(FATAL_ERROR "third-party/CMakeLists.txt missing. "
                      "Try updating your submodule with:
rm -r third-party
git submodule update --init --recursive
")
endif()

include("${CMAKE_CURRENT_SOURCE_DIR}/CMake/HPHPFunctions.cmake")
include(CheckFunctionExists)

set(HPHP_HOME ${CMAKE_CURRENT_SOURCE_DIR})
set(TP_DIR "${CMAKE_CURRENT_SOURCE_DIR}/third-party")

add_subdirectory(third-party)
add_subdirectory(hphp)

file(GLOB HHVM_CMAKE_FILES "CMake/*.cmake")
install(
  FILES ${HHVM_CMAKE_FILES}
  DESTINATION "${CMAKE_INSTALL_PREFIX}/lib/hphp/CMake"
  COMPONENT dev)

=== hphp/CMakeLists.txt ===
#
#   +----------------------------------------------------------------------+
#   | HipHop for PHP                                                       |
#   +----------------------------------------------------------------------+
#   | Copyright (c) 2010 Facebook, Inc. (http://www.facebook.com)          |
#   | Copyright (c) 1997-2010 The PHP Group                                |
#   +----------------------------------------------------------------------+
#   | This source file is subject to version 3.01 of the PHP license,      |
#   | that is bundled with this package in the file LICENSE, and is        |
#   | available through the world-wide-web at the following url:           |
#   | http://www.php.net/license/3_01.txt                                  |
#   | If you did not receive a copy of the PHP license and are unable to   |
#   | obtain it through the world-wide-web, please send a note to          |
#   | license@php.net so we can mail you a copy immediately.               |
#   +----------------------------------------------------------------------+
#

if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/facebook")
  # I'm sorry, but facebook's internal repo has the top level dir stored inside
  # of hphp/, so we need to pull that one in first if it exists
  CMAKE_MINIMUM_REQUIRED(VERSION 2.8.7 FATAL_ERROR)
  set(HPHP_HOME ${CMAKE_CURRENT_SOURCE_DIR}/..)
  set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/facebook/CMake"
                        "${CMAKE_CURRENT_SOURCE_DIR}/public_tld/CMake"
                        ${CMAKE_MODULE_PATH})
  include(FBTLD)
endif()

include(HPHPSetup)
include(FollySetup)
if (ENABLE_COTIRE)
  include(cotire)
  FIND_PATH(LIBC_INCLUDE_PATH stdlib.h)

  # Detect the architecture-specific include directory
  IF("${CMAKE_LIBRARY_ARCHITECTURE}" STREQUAL "")
    # For CentOS/Red Hat where they store it directly in /usr/include
    SET(ARCH_INCLUDE_PATH "${LIBC_INCLUDE_PATH}/bits")
  ELSE()
    FIND_PATH(ARCH_INCLUDE_PATH ${CMAKE_LIBRARY_ARCHITECTURE})
    SET(ARCH_INCLUDE_PATH "${ARCH_INCLUDE_PATH}/${CMAKE_LIBRARY_ARCHITECTURE}")
  ENDIF()

  set_property(DIRECTORY
    PROPERTY COTIRE_PREFIX_HEADER_IGNORE_PATH
      "${LIBC_INCLUDE_PATH}/stdlib.h"
      "${LIBC_INCLUDE_PATH}/string.h"
      "${LIBC_INCLUDE_PATH}/ansidecl.h"
      "${LIBC_INCLUDE_PATH}/bfd.h"
      "${LIBC_INCLUDE_PATH}/libelf.h"
      "${LIBC_INCLUDE_PATH}/elf.h"
      "${LIBC_INCLUDE_PATH}/gelf.h"
      "${ARCH_INCLUDE_PATH}"
      "${CCLIENT_INCLUDE_PATH}"
      "${JEMALLOC_INCLUDE_DIR}/jemalloc"
      "${ONIGURUMA_INCLUDE_DIR}/onigposix.h"
      "${ONIGURUMA_INCLUDE_DIR}/oniguruma.h"
      "${LIBPNG_INCLUDE_DIRS}/png.h"
      "${LDAP_INCLUDE_DIR}/ldap.h"
      "${CMAKE_SOURCE_DIR}"
      "${CMAKE_BINARY_DIR}")
endif()

add_definitions("-DHHVM")
add_definitions("-DUSE_CMAKE")

add_subdirectory(tools/bootstrap)

add_subdirectory(compiler)
add_subdirectory(hack)
add_subdirectory(hhbbc)
add_subdirectory(neo)
add_subdirectory(parser)

add_subdirectory(runtime)
add_subdirectory(runtime/ext)
add_subdirectory(runtime/ext_hhvm)
if (ENABLE_ZEND_COMPAT)
  add_subdirectory(runtime/ext_zend_compat)
endif()
add_subdirectory(system)
add_subdirectory(util)
add_subdirectory(vixl)
add_subdirectory(zend)

add_subdirectory(hhvm)

option(TEST_BIN "Create the HHVM test binary" OFF)
if (TEST_BIN)
  add_subdirectory(test)
endif ()

# Keep this last
add_subdirectory(tools/hphpize)

=== third-party/CMakeLists.txt ===
#
#   +----------------------------------------------------------------------+
#   | HipHop for PHP                                                       |
#   +----------------------------------------------------------------------+
#   | Copyright (c) 2010 Facebook, Inc. (http://www.facebook.com)          |
#   | Copyright (c) 1997-2010 The PHP Group                                |
#   +----------------------------------------------------------------------+
#   | This source file is subject to version 3.01 of the PHP license,      |
#   | that is bundled with this package in the file LICENSE, and is        |
#   | available through the world-wide-web at the following url:           |
#   | http://www.php.net/license/3_01.txt                                  |
#   | If you did not receive a copy of the PHP license and are unable to   |
#   | obtain it through the world-wide-web, please send a note to          |
#   | license@php.net so we can mail you a copy immediately.               |
#   +----------------------------------------------------------------------+
#

include(HPHPSetup)
include(FollySetup)

add_definitions("-DHHVM")

set(THIRD_PARTY_MODULES)
set(THIRD_PARTY_HEADERS)

list(APPEND THIRD_PARTY_MODULES
  fastlz
  libafdt
  libmbfl
  libsqlite3
  timelib
  lz4
  double-conversion
  folly
  libzip)
if(ENABLE_FASTCGI)
  list(APPEND THIRD_PARTY_MODULES ti)
  list(APPEND THIRD_PARTY_MODULES thrift)
endif()

function(TP_INSTALL_HEADERS TARGET SRCDIR DEST)
  file(GLOB_RECURSE files "${SRCDIR}/*.h")
  install(
    CODE "INCLUDE(\"${HPHP_HOME}/CMake/HPHPFunctions.cmake\")
      HHVM_INSTALL_HEADERS(${TARGET}
      \"${CMAKE_CURRENT_SOURCE_DIR}/${SRCDIR}\"
      \"\${CMAKE_INSTALL_PREFIX}/include/hphp/third-party/${DEST}\"
      ${files})"
    COMPONENT dev)
endfunction()

foreach(MODULE ${THIRD_PARTY_MODULES})
  add_subdirectory(${MODULE})
  # Install headers here, rather than in the individual submodules, so that we
  # can easily control the destination. Put them in include/hphp/third-party.
  if(MODULE STREQUAL folly)
    TP_INSTALL_HEADERS(folly folly/src/folly folly)
  elseif(MODULE STREQUAL double-conversion)
    TP_INSTALL_HEADERS(double-conversion double-conversion/src double-conversion)
  else()
    TP_INSTALL_HEADERS(${MODULE} ${MODULE} ${MODULE})
  endif()
endforeach()

=== hphp/compiler/CMakeLists.txt ===
set(SOURCE_SUBDIRS expression statement analysis system util parser)
set(files)
set(CXX_SOURCES)
set(C_SOURCES)

auto_sources(files "*.cpp" "${SOURCE_SUBDIRS}")
list(APPEND CXX_SOURCES ${files})

auto_sources(files "*.c" "${SOURCE_SUBDIRS}")
list(APPEND C_SOURCES ${files})

auto_sources(files "*.h" "{$SOURCE_SUBDIRS}")
HHVM_PUBLIC_HEADERS(compiler ${files})


set(ERROR_INC "analysis/core_code_error.inc")

set(ERROR_INC_FILE "${CMAKE_CURRENT_SOURCE_DIR}/analysis/code_error.inc")

file(REMOVE "${ERROR_INC_FILE}")

file(WRITE "${ERROR_INC_FILE}" "/* This file is auto generated */")

foreach (error_file ${ERROR_INC})
  file(READ ${error_file} file_contents)

  file(APPEND "${ERROR_INC_FILE}" "${file_contents}")
endforeach (error_file ${ERROR_INC})

include_directories("${CMAKE_CURRENT_SOURCE_DIR}/../")

set(CMAKE_CURRENT_BINARY_DIR "${CMAKE_SOURCE_DIR}/bin")

foreach (CXX_FILE ${CXX_SOURCES})
  if(${CXX_FILE} MATCHES ".no.cpp$")
    SET_SOURCE_FILES_PROPERTIES(
      ${CXX_FILE}
      PROPERTIES
      COMPILE_FLAGS -O0
    )
  endif()
endforeach()

add_definitions(-DALWAYS_ASSERT=1)

ADD_LIBRARY(hphp_analysis STATIC ${CXX_SOURCES} ${C_SOURCES})
target_link_libraries(hphp_analysis ${Boost_LIBRARIES})
add_dependencies(hphp_analysis hphp_parser)
if (ENABLE_COTIRE)
  cotire(hphp_analysis)
endif()

=== hphp/hack/CMakeLists.txt ===
find_package(OCaml)

if (OCAMLC_FOUND)
  # This is totally the wrong way to do this, but I am tired of fighting with
  # build systems and don't really care to make this work the right way. libelf
  # is all we need right now ayways.
  unset(hackcflags)
  foreach(lib ${LIBELF_INCLUDE_DIRS})
    list(APPEND hackcflags -ccopt -I${lib})
  endforeach()
  if(ELF_GETSHDRSTRNDX)
    list(APPEND hackcflags -ccopt -DHAVE_ELF_GETSHDRSTRNDX)
  endif()

  foreach(lib ${LIBELF_LIBRARIES})
    get_filename_component(pth ${lib} PATH)
    get_filename_component(base ${lib} NAME_WE)
    string(REGEX REPLACE "^lib" "" libname ${base})
    list(APPEND hackcflags -ccopt -L${pth} -cclib -l${libname})
  endforeach()

  add_custom_target(
    hack
    ALL
    COMMAND $(MAKE) depend &&
      env OPTBIN="${OCAMLC_OPT_SUFFIX}"
          OCAMLCFLAGS_EXTRA="${hackcflags}"
          $(MAKE)
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/src"
  )
endif()

=== hphp/hhbbc/CMakeLists.txt ===
set(CXX_SOURCES)
auto_sources(files "*.cpp" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND CXX_SOURCES ${files})

auto_sources(files "*.h" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}")
HHVM_PUBLIC_HEADERS(hhbc ${files})


# remove anything in a test folder
foreach (file ${CXX_SOURCES})
  if (${file} MATCHES "/test/")
    list(REMOVE_ITEM CXX_SOURCES ${file})
  endif()
endforeach(file ${CXX_SOURCES})

add_library(hphp_hhbbc STATIC ${CXX_SOURCES})
add_dependencies(hphp_hhbbc hphp_system)
if (ENABLE_COTIRE)
  cotire(hphp_hhbbc)
endif()

=== hphp/hhvm/CMakeLists.txt ===
set(CXX_SOURCES)
auto_sources(files "*.cpp" "")
list(APPEND CXX_SOURCES ${files})

add_executable(hhvm ${CXX_SOURCES})
target_link_libraries(hhvm ${HHVM_LINK_LIBRARIES})
embed_all_systemlibs(hhvm "${CMAKE_CURRENT_BINARY_DIR}/.." "${CMAKE_CURRENT_BINARY_DIR}/hhvm")
add_dependencies(hhvm systemlib)
if (ENABLE_COTIRE)
  cotire(hhvm)
endif()

HHVM_INSTALL(hhvm bin)

auto_sources(files "*.h" "")
HHVM_PUBLIC_HEADERS(hhvm ${files})

=== hphp/neo/CMakeLists.txt ===
set(CXX_SOURCES)
auto_sources(files "*.c" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND CXX_SOURCES ${files})

add_library(neo STATIC ${CXX_SOURCES})

auto_sources(files "*.h" "RECURSE")
HHVM_PUBLIC_HEADERS(neo ${files})

if (ENABLE_COTIRE)
  cotire(neo)
endif()

=== hphp/parser/CMakeLists.txt ===
set(CXX_SOURCES)
auto_sources(files "*.cpp" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND CXX_SOURCES ${files})

add_library(hphp_parser STATIC ${CXX_SOURCES})

auto_sources(files "*.h" "${CMAKE_CURRENT_SOURCE_DIR}")
HHVM_PUBLIC_HEADERS(parser ${files})

if (ENABLE_COTIRE)
  cotire(hphp_parser)
endif()

=== hphp/runtime/CMakeLists.txt ===
set(RECURSIVE_SOURCE_SUBDIRS base debugger eval server vm)
foreach (dir ${RECURSIVE_SOURCE_SUBDIRS})
  HHVM_SELECT_SOURCES("${CMAKE_CURRENT_SOURCE_DIR}/${dir}")
endforeach(dir ${RECURSIVE_SOURCE_SUBDIRS})

if(NOT LINUX)
  add_definitions(-DNO_HARDWARE_COUNTERS)
  list(REMOVE_ITEM CXX_SOURCES
       ${CMAKE_CURRENT_SOURCE_DIR}/vm/debug/elfwriter.cpp)
endif()

if(NOT ENABLE_FASTCGI)
  foreach (file ${CXX_SOURCES})
    if (${file} MATCHES "/fastcgi/")
      list(REMOVE_ITEM CXX_SOURCES ${file})
    endif()
  endforeach(file ${CXX_SOURCES})
endif()

if(NOT HAVE_CUSTOM_LIBEVENT)
  # Not working with off-the-shelf libevent
  list(REMOVE_ITEM CXX_SOURCES
       "${CMAKE_CURRENT_SOURCE_DIR}/server/server-name-indication.cpp")
  foreach (file ${CXX_SOURCES})
    if(${file} MATCHES "/server/libevent-")
      list(REMOVE_ITEM CXX_SOURCES ${file})
    endif()
  endforeach(file ${CXX_SOURES})
endif()

ADD_LIBRARY(hphp_runtime_static STATIC
            ${CXX_SOURCES} ${C_SOURCES} ${ASM_SOURCES})
SET_TARGET_PROPERTIES(hphp_runtime_static PROPERTIES OUTPUT_NAME "hphp_runtime")
SET_TARGET_PROPERTIES(hphp_runtime_static PROPERTIES PREFIX "lib")
SET_TARGET_PROPERTIES(hphp_runtime_static PROPERTIES CLEAN_DIRECT_OUTPUT 1)

SET(CMAKE_CXX_ARCHIVE_APPEND "<CMAKE_AR> q <TARGET> <LINK_FLAGS> <OBJECTS>")

hphp_link(hphp_runtime_static)
HHVM_PUBLIC_HEADERS(runtime ${HEADER_SOURCES})

if (ENABLE_COTIRE)
  cotire(hphp_runtime_static)
endif()

=== hphp/system/CMakeLists.txt ===
auto_sources(IDL_SRCS "*.idl.json" "RECURSE"
             "${CMAKE_CURRENT_SOURCE_DIR}/../system/idl")

add_custom_command(
  OUTPUT "class_map.cpp" "constants.h"
  DEPENDS ${IDL_SRCS} gen-class-map
  COMMAND "${CMAKE_CURRENT_BINARY_DIR}/../tools/bootstrap/gen-class-map"
  ARGS "--system"
       "${CMAKE_CURRENT_BINARY_DIR}/class_map.cpp"
       "${CMAKE_CURRENT_SOURCE_DIR}/constants.h"
       ${IDL_SRCS}
  COMMENT "Generating class_map.cpp and constants.h")

set(CXX_SOURCES "class_map.cpp" "systemlib.cpp")

add_library(hphp_system STATIC ${CXX_SOURCES})

auto_sources(files "*.h" "${CMAKE_CURRENT_SOURCE_DIR}")
HHVM_PUBLIC_HEADERS(system ${files})

# Needed to force system/constants.h to generate prior to files which need it
if (ENABLE_ZEND_COMPAT)
  add_dependencies(hphp_ext_zend_compat hphp_system)
endif()

add_dependencies(hphp_runtime_static hphp_system)
add_dependencies(hphp_runtime_ext hphp_system)
add_dependencies(hphp_analysis hphp_system)

FILE(STRINGS "php.txt" SYSTEMLIB_CLASSES)
set(SYSTEMLIB_SRCS)
set(SYSTEMLIB_SRCS_STR)
foreach(cls ${SYSTEMLIB_CLASSES})
  STRING(REGEX REPLACE "[ \t]*#.*" "" cls "${cls}")
  if (NOT "${cls}" STREQUAL "")
    list(APPEND SYSTEMLIB_SRCS "../../${cls}")
                set(SYSTEMLIB_SRCS_STR "${SYSTEMLIB_SRCS_STR} ${cls}")
  endif()
endforeach()

add_custom_target(
  systemlib
  DEPENDS "php.txt" ${SYSTEMLIB_SRCS}
  COMMAND "INSTALL_DIR=${CMAKE_CURRENT_BINARY_DIR}"
          "FBCODE_DIR=${CMAKE_CURRENT_SOURCE_DIR}/../.."
          "${CMAKE_CURRENT_SOURCE_DIR}/../runtime/ext_hhvm/make_systemlib.sh"
          "--install_dir=${CMAKE_CURRENT_BINARY_DIR}"
          "--fbcode_dir=${CMAKE_CURRENT_SOURCE_DIR}/.."
          "${SYSTEMLIB_SRCS_STR}"
  COMMENT "Generating systemlib.php")

=== hphp/test/CMakeLists.txt ===
set(CXX_SOURCES)
add_definitions("-DHHVM_PATH=\"${CMAKE_CURRENT_SOURCE_DIR}/../hhvm/hhvm\"")

set(RECURSIVE_SOURCE_SUBDIRS ext)
foreach (dir ${RECURSIVE_SOURCE_SUBDIRS})
  auto_sources(files "*.cpp" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}/${dir}")
  list(APPEND CXX_SOURCES ${files})
endforeach(dir ${RECURSIVE_SOURCE_SUBDIRS})

list(APPEND CXX_SOURCES ${files})
list(APPEND CXX_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/../hhvm/process-init.cpp")
list(APPEND CXX_SOURCES
     "${CMAKE_CURRENT_SOURCE_DIR}/../hhvm/global-variables.cpp")

if(NOT HAVE_CUSTOM_LIBEVENT)
  list(REMOVE_ITEM CXX_SOURCES
       "${CMAKE_CURRENT_SOURCE_DIR}/ext/test_ext_curl.cpp")
endif()

if (NOT ENABLE_FASTCGI)
  list(REMOVE_ITEM CXX_SOURCES
       "${CMAKE_CURRENT_SOURCE_DIR}/ext/test_fastcgi.cpp")
  list(REMOVE_ITEM CXX_SOURCES
       "${CMAKE_CURRENT_SOURCE_DIR}/ext/test_fastcgi_protocol.cpp")
endif()

add_executable(test ${CXX_SOURCES})
target_link_libraries(test ${HHVM_LINK_LIBRARIES})
embed_all_systemlibs(test "${CMAKE_CURRENT_BINARY_DIR}/.." "${CMAKE_CURRENT_BINARY_DIR}/test")
add_dependencies(test systemlib)
if (ENABLE_COTIRE)
  cotire(test)
endif()

## hhvm 3.11.0+dfsg

=== debian/changelog ===
hhvm (3.11.0+dfsg-1) unstable; urgency=medium

  [ Faidon Liambotis ]
  * New upstream release.
  * Build with stock gcc again; folly's gcc 5.0 issues have been fixed.
  * Refresh all debian/patches; drop:
    - support-more-sql-stats: merged upstream
    - ezc-fix-z-type-in-zend_parse_parameters: was a backport
    - use_system_TZinfo: merged upstream
    - fix_freetype_include: unused/unneeded
    - hack_license.patch: obsolete
    - license_folly.patch: superfluous
  * Drop our own debian/-shipped manpages, as these have been merged into the
    upstream tree instead and enhanced since.
  * Add Build-depends on gawk, gperf, libboost-context-dev, libre2-dev,
    libgmp-dev.
  * Build-depend on libjpeg-dev instead of libjpeg62-dev. (Closes: #796932)
  * Build-depend on libvpx-dev to enable WebP support for gd.
  * Drop libiconv-hook-dev dependency and associated patch, libc6's iconv.h
    should be enough for HHVM and it doesn't appear like upstream's intention
    was ever to link against libiconv-hook.
  * Disable asynchronous MySQL support; it depends on the webscalesql fork of
    libmysqlclient-dev which is not packaged separately in Debian. Upstream
    bundles it under their third-party repository but it has been stripped
    from this packaging as the full forked MySQL 5.6 source is too big to be
    embedded into this package.
  * Drop patch enable_relro_hack, that enabled hardening (relro) for
    hh_client/hh_server. Current recommendation by the OCaml team is to not
    attempt to do any hardening until the OCaml runtime itself gets fixed
    first (#702349).
  * Add patch fix_stats_error to fix a MySQL statistics collection error.
  * Add patch fix-makeparser-bison3 to fix a make-parser.sh incompatibility
    when ran with Bison3.
  * Set HOME to debian/build when running the tests so that HHVM can write the
    HHBC even when $HOME does not exist, or to not leave garbage behind when
    it exists.
  * Switch our Provides: hhvm-api-$version to the major/minor HHVM released,
    based on upstream's recommendation of using HHVM_VERSION_BRANCH.
  * Remove sources of build variance to hopefully make the build reproducible:
    - Pass $COMPILER_ID to the compilation process, based on the
      package's version from debian/changelog.
    - Add patch reproducible-sort to pass LC_ALL=C to sort.
    - Add patch reproducible-hack-builddate to remove __DATE__/__TIME__.
      embedding from the Hack source code.
    - Add patch reproducible-hack-compilerid to force hack into using
      $COMPILER_ID instead of always using "git rev-parse".
  * Update debian/copyright with copyright information for files new in this
    version (mainly libraries shipped under third-party/).
  * Switch HHBC location path to /var/cache/hhvm, instead of /var/run/hhvm,
    since it can get large, there is little benefit from having it in memory
    and it can persist across reboots.
  * Switch default source root to /var/www/html.
  * Switch logging to syslog instead of custom, non-logrotated path in
    /var/log.
  * Ship /usr/bin/hh_format, the Hack formatter.
  * Ship hhvm-gdb and hhvm-leak-isolator in the hhvm-dbg package. This adds a
    Depends: python to the -dbg package, which is probably okay given
    hhvm-dbg's relative size to python, as well as its niche usage.
  * Recommend gdb from hhvm-dbg, as the symbols aren't very useful without
    gdb, and hhvm-gdb is a shell script that calls gdb.
  * Cleanup and update /etc/default/hhvm.
  * Update debian/watch.

  [ Giuseppe Lavagetto ]
  * Move the init script to using /lib/init/init-d-script.
  * Add upstart and systemd service files.

 -- Faidon Liambotis <paravoid@debian.org>  Tue, 29 Dec 2015 02:57:38 +0200

hhvm (3.3.5+dfsg-1) unstable; urgency=medium

  [ David Martínez Moreno ]
  * New upstream release.  Release date was 2015-03-04.  3.3 is the first LTS
    version of HHVM ever, which will have support for six months until mid
    August 2015.  The main features from 3.3.5 are:
    - Support for async lambda functions in Hack.
    - Destructors for objects that are still alive at the end of the request
      are now called by default.
    - Much more of XDebug is implemented (including remote debugging and
      profiling).
    - Implemented APCIterator.
    - INI settings are now more widely supported, and more consistent.
    - Added a <<__Memoize>> user attribute for non-static methods with 0
      arguments.
    - Added the GMP extension.
    - It is now possible to load dynamic extensions from INI files.
    - Multiple ‘default’ blocks in a single switch are now a parse error.
    - Improved reflection compatibility.
    - Added typechecker support for interface requirements (similar to trait
      requirements).
    - Added support for PHP5.6-style argument unpacking: f($x, $y, ….$args).
    - Assorted performance and memory usage improvements.
    - Many extensions converted to HNI.
    - Improved HNI support for variadic functions.
    - hhvm-dev package added, making it possible to build some third-party
      extensions without rebuilding HHVM itself.
    - Many security fixes for PHP CVEs backported from PHP trunk and some of
      them from HHVM itself.  In particular, CVE-2015-4663, CVE-2015-3413 and
      CVE-2015-4024 are fixed in this release.
  * debian/control: Depend on g++-4.9, as folly doesn't build on gcc-5.2.
  * debian/patches:
    - use_system_libzip: Merged.
    - use_system_libsqlite3: Merged.
    - use_system_lz4: Merged.
    - use_system_double_conversion: Merged.
    - fix_hphp_lexer: Merged.
    - disable_quicklz_code: Merged.
    - static_linking_against_libbfd: Merged.
    - add_additional_includes_imagemagick: Merged.
    - replace_obsolete_lz4_uncompress: Merged.
    - fix_freetype_include: Refreshed.
    - typos: Refreshed.
    - pass-DNDEBUG-to-RelWithDebInfo: Refreshed.
    - enable_relro_hack: The Hack binaries don't obey normal CFLAGS, so add
      manually the -z,relro option in the CMake config.


=== debian/control ===
Source: hhvm
Section: php
Priority: optional
Maintainer: Debian HHVM packaging team <pkg-hhvm-team@lists.alioth.debian.org>
Uploaders: David Martínez Moreno <ender@debian.org>, Faidon Liambotis <paravoid@debian.org>
Build-Depends: debhelper (>= 9.0.0),
  autotools-dev,
  binutils-dev,
  bison,
  chrpath,
  cmake,
  flex,
  gawk,
  gperf,
  libboost-dev,
  libboost-context-dev,
  libboost-filesystem-dev,
  libboost-program-options-dev,
  libboost-regex-dev,
  libboost-system-dev,
  libboost-thread-dev,
  libbz2-dev,
  libcap-dev,
  libc-client2007e-dev,
  libcurl4-openssl-dev,
  libdouble-conversion-dev,
  libdwarf-dev,
  libedit-dev,
  libelf-dev,
  libevent-dev,
  libexpat1-dev,
  libfreetype6-dev,
  libgmp-dev,
  libgoogle-glog-dev,
  libiberty-dev,
  libicu-dev,
  libinotifytools0-dev,
  libjemalloc-dev,
  libjpeg-dev,
  libjson-c-dev,
  libldap2-dev,
  liblz4-dev,
  libmagickcore-dev,
  libmagickwand-dev,
  libmcrypt-dev,
  libmemcached-dev,
  libmysqlclient-dev,
  libonig-dev,
  libpcre3-dev,
  libpng12-dev,
  libre2-dev,
  libsqlite3-dev,
  libssl-dev,
  libtbb-dev,
  libvpx-dev,
  libxml2-dev,
  libxslt1-dev,
  libyaml-dev,
  libzip-dev (>= 0.11),
  ocaml-native-compilers,
  pkg-config,
  unixodbc-dev,
  zlib1g-dev
Standards-Version: 3.9.6
Homepage: http://hhvm.com/
Vcs-Git: git://anonscm.debian.org/pkg-hhvm/hhvm.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-hhvm/hhvm.git;a=summary

Package: hhvm
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: ${hhvm:ApiVersion}
Description: HipHop Virtual Machine, a JIT replacement for PHP - main runtime
 HHVM is an open-source virtual machine designed for executing programs
 written in Hack and PHP. HHVM uses a just-in-time (JIT) compilation
 approach to achieve superior performance while maintaining the development
 flexibility that PHP provides.
 .
 For the majority of your programs HHVM should be a drop-in replacement for
 the usual PHP interpreter/engine.

Package: hhvm-dbg
Architecture: amd64
Depends: hhvm (= ${binary:Version}), python, ${misc:Depends}
Recommends: gdb
Section: debug
Priority: extra
Description: HipHop Virtual Machine, a JIT replacement for PHP - debugging symbols
 HHVM is an open-source virtual machine designed for executing programs
 written in Hack and PHP. HHVM uses a just-in-time (JIT) compilation
 approach to achieve superior performance while maintaining the development
 flexibility that PHP provides.
 .
 For the majority of your programs HHVM should be a drop-in replacement for
 the usual PHP interpreter/engine.
 .
 This package provides the debugging symbols for HHVM.

Package: hhvm-dev
Architecture: amd64
Depends: ${misc:Depends}, cmake
Section: libdevel
Priority: extra
Description: HipHop Virtual Machine, a JIT replacement for PHP - development files
 HHVM is an open-source virtual machine designed for executing programs
 written in Hack and PHP. HHVM uses a just-in-time (JIT) compilation
 approach to achieve superior performance while maintaining the development
 flexibility that PHP provides.
 .
 For the majority of your programs HHVM should be a drop-in replacement for
 the usual PHP interpreter/engine.
 .
 This package provides the header & build system files needed for compiling
 HHVM extensions.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1
# To prevent bogus linkage.
LDFLAGS += -Wl,--as-needed

# used to store HHBC during tests
BUILDHOME = $(CURDIR)/debian/build

# Exported variable to make sure that we don't use cursor control in the tests.
export TRAVIS = bogus

# Contrary to its confusing name, this is actually the build's revision ID.
# hphp/util/generate-buildinfo.sh uses:
#   $COMPILER_ID -> git describe -> hg log -> date
# We want to avoid relying on git (because we may building from the .dsc) and
# date (because that would add variance to the build)
export COMPILER_ID = $(shell dpkg-parsechangelog -SVersion)

%:
	dh $@ --parallel

override_dh_auto_build:
	# rerun flex/bison to regenerate their output for DFSG reasons
	./hphp/parser/make-lexer.sh
	./hphp/parser/make-parser.sh
	VERBOSE=1 dh_auto_build

override_dh_auto_configure:
	printenv
	echo $(LDFLAGS)
	dh_auto_configure -- \
		-DUSE_JSONC=ON \
		-DFREETYPE_INCLUDE_DIRS=/usr/include/freetype2/ \
		-DENABLE_ASYNC_MYSQL=OFF \
		-DMYSQL_UNIX_SOCK_ADDR=/dev/null \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	# HHVM by default uses ~/.hhvm.hhbc, but ~ isn't guranteed to exist.
	-mkdir $(BUILDHOME)
	HOME=$(BUILDHOME) hphp/hhvm/hhvm hphp/test/run -m jit quick
	HOME=$(BUILDHOME) hphp/hhvm/hhvm hphp/test/run -m interp quick
endif

override_dh_clean:
	dh_clean
	-rm -rf $(BUILDHOME)

override_dh_gencontrol:
	# see hphp/runtime/version.h, HHVM_VERSION_BRANCH
	hhvmapi=$(shell $(CURDIR)/debian/hhvm/usr/bin/hhvm --version | sed -ne 's/^HipHop VM \(.*\)\..*/\1/p') && \
		[ -n "$${hhvmapi}" ] && echo "hhvm:ApiVersion=hhvm-api-$${hhvmapi}" >> debian/hhvm.substvars
	dh_gencontrol

override_dh_strip:
	dh_strip --dbg-package=hhvm-dbg

override_dh_fixperms:
	dh_fixperms
	chown www-data:www-data \
		$(CURDIR)/debian/hhvm/var/cache/hhvm

## hhvm 3.11.1%2Bdfsg

=== third-party/CMakeLists.txt ===
--- 
+++ 
@@ -24,18 +24,66 @@
 set(THIRD_PARTY_HEADERS)
 
 list(APPEND THIRD_PARTY_MODULES
-  fastlz
-  libafdt
-  libmbfl
-  libsqlite3
   timelib
-  lz4
-  double-conversion
   folly
-  libzip)
+  wangle
+)
 if(ENABLE_FASTCGI)
-  list(APPEND THIRD_PARTY_MODULES ti)
+  list(APPEND THIRD_PARTY_MODULES proxygen)
   list(APPEND THIRD_PARTY_MODULES thrift)
+endif()
+
+if (NOT MSVC)
+  list(APPEND THIRD_PARTY_MODULES libafdt)
+endif()
+
+# Add bundled libmbfl if the system one will not be used
+if(NOT LIBMBFL_LIBRARY)
+  list(APPEND THIRD_PARTY_MODULES libmbfl)
+endif()
+
+if(ENABLE_ASYNC_MYSQL)
+  find_package(RE2)
+  if(NOT RE2_LIBRARY)
+    message(STATUS "Building RE2 from third-party")
+    list(APPEND THIRD_PARTY_MODULES re2)
+  endif()
+  list(APPEND THIRD_PARTY_MODULES squangle)
+  list(APPEND THIRD_PARTY_MODULES webscalesqlclient)
+endif()
+
+if (ENABLE_MCROUTER)
+  list(APPEND THIRD_PARTY_MODULES mcrouter)
+endif()
+
+# Add bundled fastlz if the system one will not be used
+if(NOT FASTLZ_LIBRARY)
+  list(APPEND THIRD_PARTY_MODULES fastlz)
+endif()
+
+# Add bundled libsqlite3 if the system one will not be used
+if(NOT LIBSQLITE3_LIBRARY)
+  list(APPEND THIRD_PARTY_MODULES libsqlite3)
+endif()
+
+# Add bundled lz4 if the system one will not be used
+if(NOT LZ4_LIBRARY)
+  list(APPEND THIRD_PARTY_MODULES lz4)
+endif()
+
+# Add bundled double-conversion if the system one will not be used
+if(NOT DOUBLE_CONVERSION_LIBRARY)
+  list(APPEND THIRD_PARTY_MODULES double-conversion)
+endif()
+
+# Add bundled PCRE if the system one will not be used
+if(NOT PCRE_LIBRARY)
+  list(APPEND THIRD_PARTY_MODULES pcre)
+endif()
+
+# Add bundled libzip if the system one will not be used
+if(NOT LIBZIP_LIBRARY)
+  list(APPEND THIRD_PARTY_MODULES libzip)
 endif()
 
 function(TP_INSTALL_HEADERS TARGET SRCDIR DEST)
@@ -55,8 +103,8 @@
   # can easily control the destination. Put them in include/hphp/third-party.
   if(MODULE STREQUAL folly)
     TP_INSTALL_HEADERS(folly folly/src/folly folly)
-  elseif(MODULE STREQUAL double-conversion)
-    TP_INSTALL_HEADERS(double-conversion double-conversion/src double-conversion)
+  elseif(NOT DOUBLE_CONVERSION_LIBRARY AND MODULE STREQUAL double-conversion)
+    TP_INSTALL_HEADERS(double-conversion double-conversion/src/double-conversion double-conversion)
   else()
     TP_INSTALL_HEADERS(${MODULE} ${MODULE} ${MODULE})
   endif()

=== hphp/hhvm/CMakeLists.txt ===
set(CXX_SOURCES)
auto_sources(files "*.cpp" "")
list(APPEND CXX_SOURCES ${files})

# Windows targets use a generated rc file for embedding libraries
if(CYGWIN OR MSVC OR MINGW)
  list(APPEND CXX_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/embed.rc)
endif()

find_package(Gold)

if (GOLD_FOUND)
  SET(LINKER_SCRIPT -fuse-ld=gold -Wl,--section-ordering-file,${CMAKE_CURRENT_SOURCE_DIR}/../tools/oss_hot_section_ordering,--icf=all,--gc-sections)
  add_executable(hhvm ${CXX_SOURCES})
  target_link_libraries(hhvm ${HHVM_LINK_LIBRARIES} ${LINKER_SCRIPT})
else()
  add_executable(hhvm ${CXX_SOURCES})
  target_link_libraries(hhvm ${HHVM_LINK_LIBRARIES})
endif()

# cygwin has an issue with linking to crypt and intl
# this is the only way the redirection stuff works
if(CYGWIN)
  target_link_libraries(hhvm crypt)
  target_link_libraries(hhvm intl)
  target_link_libraries(hhvm dbghelp)
endif()

# Check whether atomic operations require -latomic or not
# See https://github.com/facebook/hhvm/issues/5217
INCLUDE(CheckCXXSourceCompiles)
set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
set(CMAKE_REQUIRED_FLAGS "-std=c++11")
CHECK_CXX_SOURCE_COMPILES("
#include <atomic>
int main() {
    struct Test { int val; };
    std::atomic<Test> s;
    s.is_lock_free();
}
" NOT_REQUIRE_ATOMIC_LINKER_FLAG)

if(NOT "${NOT_REQUIRE_ATOMIC_LINKER_FLAG}")
    message(STATUS "-latomic is required to link hhvm")
    target_link_libraries(hhvm atomic)
endif()
set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQUIRED_FLAGS})

embed_all_systemlibs(hhvm "${CMAKE_CURRENT_BINARY_DIR}/.." "${CMAKE_CURRENT_BINARY_DIR}/hhvm")
add_dependencies(hhvm systemlib)

if (CMAKE_HOST_UNIX)
  add_custom_command(TARGET hhvm POST_BUILD
    COMMAND INSTALL_DIR=${CMAKE_CURRENT_BINARY_DIR} sh "${CMAKE_CURRENT_SOURCE_DIR}/symlinks.sh"
    COMMENT "Creating symlinks for hhvm")
endif()

if (ENABLE_COTIRE)
  cotire(hhvm)
endif()

HHVM_INSTALL(hhvm bin)

auto_sources(files "*.h" "")
HHVM_PUBLIC_HEADERS(hhvm ${files})

=== hphp/runtime/CMakeLists.txt ===
set(RECURSIVE_SOURCE_SUBDIRS base debugger eval server vm)
foreach (dir ${RECURSIVE_SOURCE_SUBDIRS})
  HHVM_SELECT_SOURCES("${CMAKE_CURRENT_SOURCE_DIR}/${dir}")
endforeach(dir ${RECURSIVE_SOURCE_SUBDIRS})
list(APPEND HEADER_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/version.h")

if(NOT LINUX)
  list(REMOVE_ITEM CXX_SOURCES
       ${CMAKE_CURRENT_SOURCE_DIR}/vm/debug/elfwriter.cpp)
  list(REMOVE_ITEM HEADER_SOURCES
       ${CMAKE_CURRENT_SOURCE_DIR}/vm/debug/elfwriter.h)
endif()

if(NOT ENABLE_FASTCGI)
  HHVM_REMOVE_MATCHES_FROM_LISTS(CXX_SOURCES HEADER_SOURCES
    MATCHES "/fastcgi/")
endif()

if(NOT ENABLE_PROXYGEN_SERVER)
  HHVM_REMOVE_MATCHES_FROM_LISTS(CXX_SOURCES HEADER_SOURCES
    MATCHES "/proxygen/")
endif()

if(NOT HAVE_CUSTOM_LIBEVENT)
  HHVM_REMOVE_MATCHES_FROM_LISTS(CXX_SOURCES HEADER_SOURCES
    MATCHES "/server/libevent-")
endif()

add_custom_command(
  OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/ir-opcode-generated.h"
  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/../doc/generate-ir-opcodes.sh"
  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/../doc/ir.specification"
          "${CMAKE_CURRENT_SOURCE_DIR}/../doc/generate-ir-opcodes.pl"
          "${CMAKE_CURRENT_SOURCE_DIR}/../doc/generate-ir-opcodes.sh"
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMENT "Generating HHIR opcode table"
  VERBATIM)

add_precompiled_header(
  "${HPHP_HOME}/hphp/pch/hphp_runtime_static.h"
  "${HPHP_HOME}/hphp/pch/hphp_runtime_static.cpp"
  CXX_SOURCES
)

ADD_LIBRARY(hphp_runtime_static STATIC
            ${CXX_SOURCES} ${C_SOURCES} ${ASM_SOURCES} ${HEADER_SOURCES}
            "ir-opcode-generated.h")
auto_source_group("hphp_runtime_static" "${CMAKE_CURRENT_SOURCE_DIR}"
  ${ASM_SOURCES} ${C_SOURCES} ${CXX_SOURCES} ${HEADER_SOURCES})
SET_TARGET_PROPERTIES(hphp_runtime_static PROPERTIES OUTPUT_NAME "hphp_runtime")
SET_TARGET_PROPERTIES(hphp_runtime_static PROPERTIES PREFIX "lib")
SET_TARGET_PROPERTIES(hphp_runtime_static PROPERTIES CLEAN_DIRECT_OUTPUT 1)

SET(CMAKE_CXX_ARCHIVE_APPEND "<CMAKE_AR> q <TARGET> <LINK_FLAGS> <OBJECTS>")

hphp_link(hphp_runtime_static)
HHVM_PUBLIC_HEADERS(runtime ${HEADER_SOURCES})

if (ENABLE_COTIRE)
  cotire(hphp_runtime_static)
endif()

if(CYGWIN AND CMAKE_BUILD_TYPE MATCHES "Debug")
  set_source_files_properties(
    ${CMAKE_CURRENT_SOURCE_DIR}/vm/jit/hhbc-translator.cpp
    PROPERTIES COMPILE_FLAGS -Og)
endif()

set(EZC_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../runtime/ext_zend_compat/")
include_directories("${EZC_DIR}/php-src")
include_directories("${EZC_DIR}/php-src/main")
include_directories("${EZC_DIR}/php-src/Zend")
include_directories("${EZC_DIR}/php-src/TSRM")

=== hphp/test/CMakeLists.txt ===
--- 
+++ 
@@ -17,13 +17,6 @@
        "${CMAKE_CURRENT_SOURCE_DIR}/ext/test_ext_curl.cpp")
 endif()
 
-if (NOT ENABLE_FASTCGI)
-  list(REMOVE_ITEM CXX_SOURCES
-       "${CMAKE_CURRENT_SOURCE_DIR}/ext/test_fastcgi.cpp")
-  list(REMOVE_ITEM CXX_SOURCES
-       "${CMAKE_CURRENT_SOURCE_DIR}/ext/test_fastcgi_protocol.cpp")
-endif()
-
 add_executable(test ${CXX_SOURCES})
 target_link_libraries(test ${HHVM_LINK_LIBRARIES})
 embed_all_systemlibs(test "${CMAKE_CURRENT_BINARY_DIR}/.." "${CMAKE_CURRENT_BINARY_DIR}/test")

=== hphp/runtime/ext_hhvm/CMakeLists.txt ===
set(files)
set(CXX_SOURCES)
set(C_SOURCES)
set(CXX_HEADERS)
set(EXT_HHVM_ARCH "x64")

exec_program("uname -m" OUTPUT_VARIABLE UNAME_M)
if (UNAME_M STREQUAL "aarch64")
  set(EXT_HHVM_ARCH "arm")
endif()

macro(EXT_HHVM_FILE SOURCES HEADERS REL EHHVM_ARCH SOURCE_REL BUILD_TARGET)
  set(SOURCE_ABS "${CMAKE_CURRENT_SOURCE_DIR}/${SOURCE_REL}")
  set(TARGET_ABS "${CMAKE_CURRENT_BINARY_DIR}/${SOURCE_REL}")
  set(f_SRC "${SOURCE_ABS}/${REL}")
  set(f_OBJ "${TARGET_ABS}/CMakeFiles/${BUILD_TARGET}.dir/${REL}")
  list(APPEND ${SOURCES} "${f_OBJ}.ext_hhvm.cpp")
  list(APPEND ${HEADERS} "${f_OBJ}.ext_hhvm.h")

  file(MAKE_DIRECTORY "${TARGET_ABS}/CMakeFiles/${BUILD_TARGET}.dir")
  add_custom_command(
    OUTPUT "${f_OBJ}.ext_hhvm.cpp" "${f_OBJ}.ext_hhvm.h"
    DEPENDS ${f_SRC} gen-ext-hhvm
    COMMAND gen-ext-hhvm
    ARGS ${EHHVM_ARCH} "${f_OBJ}.ext_hhvm.h" "${f_OBJ}.ext_hhvm.cpp" "${f_SRC}"
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/../../tools/bootstrap"
    COMMENT "Generating ext_hhvm wrapper for ${SOURCE_REL}/${REL}")
endmacro()

macro(EXT_HHVM_DIR SOURCES HEADERS SOURCE_REL BUILD_TARGET)
  string(LENGTH "${CMAKE_CURRENT_SOURCE_DIR}/${SOURCE_REL}" HPHP_DIR_LEN)
  auto_sources(files "*.idl.json" "RECURSE"
               "${CMAKE_CURRENT_SOURCE_DIR}/${SOURCE_REL}")
  foreach (f ${files})
    # This makes cpp files in the root path into a bogus lookup
    # But that's okay since we want it to fail anyhow
    string(REGEX REPLACE "../../system/idl/([^/]+)(/.*)?$"
                         "../../system/idl/\\1/config.cmake" DIR_CONFIG ${f})
    if (NOT EXISTS ${DIR_CONFIG} AND
                    NOT ${f} MATCHES "(.ext_hhvm.cpp|/(old-)?tests?/)")
      string(LENGTH ${f} f_LEN)
      math(EXPR f_REL_LEN "${f_LEN} - ${HPHP_DIR_LEN} - 1")
      math(EXPR f_REL_OFF "${HPHP_DIR_LEN} + 1")
      string(SUBSTRING ${f} ${f_REL_OFF} ${f_REL_LEN} f_REL)
      EXT_HHVM_FILE(${SOURCES} ${HEADERS} ${f_REL} ${EXT_HHVM_ARCH}
                    ${SOURCE_REL} ${BUILD_TARGET})
    endif()
  endforeach()
endmacro()

# Generate ext_hhvm stubs for system/idl/*.idl.json
EXT_HHVM_DIR(CXX_SOURCES CXX_HEADERS "../../system/idl" "hphp_runtime_ext")

#
## ext_hhvm_infotabs
#

set(ROOT_GEN_DIR "${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/generated")
set(GENERATED_DIR "${ROOT_GEN_DIR}/hphp/runtime/ext_hhvm/")
include_directories(BEFORE "${ROOT_GEN_DIR}")
set(INFOTABS_HEADER "${GENERATED_DIR}/ext_hhvm_infotabs.h")
set(INFOTABS_SOURCE "${GENERATED_DIR}/ext_hhvm_infotabs.cpp")

auto_sources(HPHP_IDLS "*.idl.json" "RECURSE"
             "${CMAKE_CURRENT_SOURCE_DIR}/../../system/idl")

# Generate ext_hhvm_infotabs.h based on ext_hhvm files being generated
file(WRITE ${INFOTABS_HEADER} "")
foreach (header ${CXX_HEADERS})
  file(APPEND ${INFOTABS_HEADER} "#include \"${header}\"\n")
endforeach()

# Generate ext_hhvm_infotabs.cpp
add_custom_command(
  OUTPUT ${INFOTABS_SOURCE}
  DEPENDS ${CXX_HEADERS} ${HPHP_IDLS} gen-infotabs
  COMMAND gen-infotabs
  ARGS ${INFOTABS_SOURCE} ${INFOTABS_HEADER} ${HPHP_IDLS})
list(APPEND CXX_SOURCES ${INFOTABS_SOURCE})

# Enable IDL based extensions
foreach(def ${EXTENSION_IDL_DEFINES})
  add_definitions(${def})
endforeach()

#
## Actual library
#

ADD_LIBRARY(ext_hhvm_static STATIC ${CXX_SOURCES})
target_link_libraries(ext_hhvm_static hphp_runtime_ext)
SET_TARGET_PROPERTIES(ext_hhvm_static PROPERTIES OUTPUT_NAME "ext_hhvm")
SET_TARGET_PROPERTIES(ext_hhvm_static PROPERTIES PREFIX "lib")
SET_TARGET_PROPERTIES(ext_hhvm_static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
if (ENABLE_COTIRE)
  cotire(ext_hhvm_static)
endif()

=== hphp/tools/fcache/Makefile ===

PROJECT_ROOT = ../../..
PROJECT_NAME = fcache

AUTO_SOURCES = 1
CXX_SOURCES += $(PROJECT_ROOT)/src/test/test_externals.cpp

LIBS = \
	$(LIB_DIR)/libhphp_runtime.a \
	$(ALL_LIBS)

include $(PROJECT_ROOT)/src/rules.mk
TARGETS = $(APP_TARGET)

all: $(TARGETS)

test:
	echo $(LINK_LIBS)

=== third-party/libmbfl/mbfl/CMakeLists.txt ===
# Require gawk because of use of strtonum which wasn't used before
FIND_PROGRAM(AWK_EXECUTABLE NAMES gawk)

IF(NOT AWK_EXECUTABLE)
  MESSAGE(FATAL_ERROR "HHVM requires gawk for libmbfl")
ENDIF()

SET(mbfl_files mbfilter.c mbfl_string.c mbfl_language.c mbfl_encoding.c mbfl_convert.c
mbfl_ident.c mbfl_memory_device.c mbfl_allocators.c mbfl_filter_output.c
mbfilter_pass.c mbfilter_wchar.c mbfilter_8bit.c)

add_library(mbfl STATIC ${mbfl_files} ${mbfl_filters_files} ${mbfl_nls_files})

# Generate eaw_table.h
add_custom_target(
  eaw_table
  DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/mk_eaw_tbl.awk" "${CMAKE_CURRENT_SOURCE_DIR}/EastAsianWidth.txt"
  COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/generate-eaw-table.sh ${AWK_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR} 
)
set_property(DIRECTORY APPEND PROPERTY ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_SOURCE_DIR}/eaw_table.h")
add_dependencies(mbfl eaw_table)
